Index: GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.cpp	(revision 1932)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.cpp	(revision 1942)
@@ -3,4 +3,5 @@
 #include "Ray.h"
 #include "Preprocessor.h"
+#include "ViewCellsManager.h"
 
 
@@ -10,5 +11,5 @@
 #define DEBUG_RAYCAST 0
 
-#define EXACT_BOX_CLIPPING 1
+#define EXACT_BOX_CLIPPING 0
 
 RayCaster::RayCaster(const Preprocessor &preprocessor):
@@ -38,4 +39,35 @@
 }
 
+bool
+RayCaster::ClipToViewSpaceBox(const Vector3 &origin,
+							  const Vector3 &termination,
+							  Vector3 &clippedOrigin,
+							  Vector3 &clippedTermination)
+{
+  Ray ray(origin, termination - origin, Ray::LINE_SEGMENT);	
+  ray.Precompute();
+  
+  float tmin, tmax;
+  if ((!mPreprocessor.mViewCellsManager->
+	   GetViewSpaceBox().ComputeMinMaxT(ray, &tmin, &tmax)) ||
+	  tmin>=tmax
+	  )
+	return false;
+
+  if (tmin >= 1.0f || tmax <=0.0f)
+	return false;
+  
+  if (tmin > 0.0f)
+	clippedOrigin = ray.Extrap(tmin);
+  else
+	clippedOrigin = origin;
+  
+  if (tmax < 1.0f)
+	clippedTermination = ray.Extrap(tmax);
+  else
+	clippedTermination = termination;
+  
+  return true;
+}
 
 /** Checks if ray is valid, (e.g., not in empty view space or outside the view space)
@@ -140,12 +172,20 @@
 	// degenerate rays checked by geometrical constraint...
 	//	!pruneInvalidRays || (hitA.mObject != hitB.mObject);
+
 	
 #if DEBUG_RAYCAST
 	Debug<<"PR2"<<flush;
 #endif
-
-	if (!pruneInvalidRays || hitA.mObject) 
-	{
-		VssRay *vssRay = new VssRay(hitB.mPoint,
+	const bool validSample = true;
+	if (validSample) {
+	  Vector3 clipA, clipB;
+	  if (!ClipToViewSpaceBox(hitA.mPoint,
+							  hitB.mPoint,
+							  clipA,
+							  clipB))
+		return 0;
+	  if (!pruneInvalidRays || hitA.mObject) {
+		VssRay *vssRay = new VssRay(
+									clipB,
 									hitA.mPoint,
 									hitB.mObject,
@@ -167,14 +207,15 @@
 #endif
 
-	if (castDoubleRay && (!pruneInvalidRays || hitB.mObject))
-	{
-		VssRay *vssRay = new VssRay(hitA.mPoint,
-									hitB.mPoint,
-									hitA.mObject,
-									hitB.mObject,
-									mPreprocessor.mPass,
-									simpleRay.mPdf);
-
-		if (validB)
+	  if (castDoubleRay && (!pruneInvalidRays || hitB.mObject))
+		{
+		  VssRay *vssRay = new VssRay(
+									  clipA,
+									  hitB.mPoint,
+									  hitA.mObject,
+									  hitB.mObject,
+									  mPreprocessor.mPass,
+									  simpleRay.mPdf
+									  );
+		  if (validB)
 			vssRay->mFlags |= VssRay::Valid;
 
@@ -183,10 +224,10 @@
 		++ hits;
 		//cout << "vssray 2: " << *vssRay << endl;
-	}
-	
-#if DEBUG_RAYCAST
-	Debug<<"PR4"<<flush;
-#endif
-
+		}
+#if DEBUG_RAYCAST
+	  Debug<<"PR4"<<flush;
+#endif
+	}
+	
 	return hits;
 }
Index: GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 1940)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 1942)
@@ -28,5 +28,5 @@
 #include "ObjExporter.h"
 #include "SceneGraph.h"
-#include "GlobalLinesRenderer.h"
+//#include "GlobalLinesRenderer.h"
 
 #include "ViewCellsManager.h"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/CombinedPreprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/CombinedPreprocessor.cpp	(revision 1931)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/CombinedPreprocessor.cpp	(revision 1942)
@@ -79,19 +79,23 @@
 	totalVssRays += (int)vssRays.size();
 
+	mMixtureDistribution->ComputeContributions(vssRays);
+
 	if (mExportRays) {
 	  Debug<<"Exporting rays..."<<endl<<flush;
 	  char filename[256];
+
+	  VssRayContainer contributingRays;
+	  vssRays.GetContributingRays(contributingRays, 0);
+	  sprintf(filename, "rss-crays-%04d.x3d", mPass);
+	  ExportRays(filename, contributingRays, mExportNumRays);
+
 	  sprintf(filename, "rss-rays-i%04d.x3d", mPass);
 	  ExportRays(filename, vssRays, mExportNumRays);
-	  
-	  //	  VssRayContainer contributingRays;
-	  //	  vssRays.GetContributingRays(contributingRays, 0);
-	  //	  sprintf(filename, "rss-crays-%04d.x3d", mPass);
-	  //	  ExportRays(filename, contributingRays, mExportNumRays);
+
 	  Debug<<"done."<<endl<<flush;
 	}
 
-	mMixtureDistribution->ComputeContributions(vssRays);
-
+	mMixtureDistribution->UpdateDistributions(vssRays);
+	
 	if (i - lastEvaluation >= mSamplesPerEvaluation) {
 	  mViewCellsManager->PrintPvsStatistics(mStats);
@@ -114,5 +118,7 @@
 	
   }
-  
+
+  EvalViewCellHistogram();
+
   return true;
 }
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VssRay.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VssRay.cpp	(revision 1932)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VssRay.cpp	(revision 1942)
@@ -357,16 +357,12 @@
 {
   VssRayContainer::const_iterator it = begin();
-
-  // ofstream s("contrib.log");
-
-  for (; it != end(); it++) 
-  {
-	  VssRay *ray = *it;
-
-	  // s<<"(pass="<<ray->mPass<<", c="<<ray->mPvsContribution<<")"<<endl;
-	  if (ray->mPass >= minPass && ray->mPvsContribution > 0)
-		  selected.push_back(ray);
-  }
-
+  //  ofstream s("contrib.log");
+  for (; it != end(); it++) {
+	VssRay *ray = *it;
+	//	cout<<"(pass="<<ray->mPass<<", c="<<ray->mPvsContribution<<")"<<endl;
+	if (ray->mPass >= minPass && ray->mPvsContribution > 0)
+	  selected.push_back(ray);
+  }
+  
   return (int)selected.size();
 }
Index: GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 1931)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 1942)
@@ -25,5 +25,5 @@
 unix:INCLUDEPATH += ../support/src/xerces-c-src_2_7_0/include
 
-INCLUDEPATH += ../src  $$NONGTP/Xerces/xerces/include  $$NONGTP/Zlib/include $$NONGTP/Boost $$NONGTP/Devil/include
+INCLUDEPATH += ../src ../src/QtInterface $$NONGTP/Xerces/xerces/include  $$NONGTP/Zlib/include $$NONGTP/Boost $$NONGTP/Devil/include
 
 win32:LIBPATH += GL $$NONGTP/Xerces/xerces/lib $$NONGTP/Devil/lib \
@@ -87,5 +87,5 @@
 # Input
 HEADERS += Halton.h VssRay.h VssPreprocessor.h RssTree.h GlRenderer.h \
-PreprocessorThread.h Preprocessor.h Beam.h QtGlViewer.h
+PreprocessorThread.h Preprocessor.h Beam.h 
 
 
@@ -111,11 +111,13 @@
 Trackball.cpp ObjExporter.cpp SubdivisionCandidate.cpp \
 Mailable.cpp \
-CombinedPreprocessor.cpp QtGlViewer.cpp 
+CombinedPreprocessor.cpp 
 
 SOURCES += BoostPreprocessorThread.cpp 
 
 CONFIG(qt) {
-HEADERS += QtPreprocessorThread.h QtGlRenderer.h
-SOURCES += OcclusionQuery.cpp QtPreprocessorThread.cpp QtGlRenderer.cpp
+HEADERS += QtPreprocessorThread.h QtInterface/QtGlRenderer.h \
+QtInterface/QtGlViewer.h
+SOURCES += OcclusionQuery.cpp QtPreprocessorThread.cpp \
+QtInterface/QtGlRenderer.cpp QtInterface/QtGlViewer.cpp 
 } else {
 SOURCES += BoostPreprocessorThread.cpp 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.cpp	(revision 1931)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.cpp	(revision 1942)
@@ -527,5 +527,7 @@
  
 	float contribution =
-	  mPreprocessor.mViewCellsManager->ComputeSampleContribution(*ray, true, false);
+	  mPreprocessor.mViewCellsManager->ComputeSampleContribution(*ray,
+																 true,
+																 false);
 
 	mDistributions[i]->mContribution += contribution;
@@ -536,13 +538,17 @@
   }
 
+  
+  UpdateRatios();
+}
+
+void
+MixtureDistribution::UpdateDistributions(VssRayContainer &vssRays)
+{
   // now update the distributions with all the rays
-  for (i=0; i < mDistributions.size(); i++) {
+  for (int i=0; i < mDistributions.size(); i++) {
 	mDistributions[i]->Update(vssRays);
   }
-  
-  
-  UpdateRatios();
-}
-
+}
+  
 void
 MixtureDistribution::UpdateRatios()
